unit settings;

interface

uses
  Windows, Messages, SysUtils, Controls, Forms, Classes,
  WdxFieldsProc, StdCtrls, IniFiles, dialogs, Shellapi,
  Menus, FileCtrl, Grids, Buttons, ComCtrls, StrUtils, ExtCtrls, ValEdit,
  GSPageControl, IOUtils, Types, WideStrUtils;

{$SetPEFlags IMAGE_FILE_RELOCS_STRIPPED}

type
  TPageControl = class(TGSPageControl)
  end;

type
  TSuperSettings = class(TForm)
    GroupBox1: TGroupBox;
    PFLCapt: TLabel;
    PlugList: TListBox;
    PLCapt: TLabel;
    FieldsList: TListBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Close1: TMenuItem;
    Selectpluginfolder1: TMenuItem;
    Rescanpluginsfolder1: TMenuItem;
    About1: TMenuItem;
    Acceptcontentstring1: TMenuItem;
    PopupMenu1: TPopupMenu;
    AddThisFieldtoContentString1: TMenuItem;
    PopupMenu2: TPopupMenu;
    Delete1: TMenuItem;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Pasteextencioncontentstring1: TMenuItem;
    Deleteextencioncontentstring1: TMenuItem;
    Save1: TMenuItem;
    Plugins1: TMenuItem;
    Language1: TMenuItem;
    Copyextenciondetectstring1: TMenuItem;
    N2: TMenuItem;
    Pasteextencioncontentstring2: TMenuItem;
    SelLNG: TOpenDialog;
    PopupMenu3: TPopupMenu;
    Default1: TMenuItem;
    Directory1: TMenuItem;
    Options1: TMenuItem;
    UseDEFvalues1: TMenuItem;
    Changeextension1: TMenuItem;
    Changeextension2: TMenuItem;
    Showerrorcode1: TMenuItem;
    Replaceemptyfieldvaluestofilename1: TMenuItem;
    ListBoxesPanel: TPanel;
    SplitterBeetwenListBoxes: TSplitter;
    Addcolumn1: TMenuItem;
    Deletecolumn1: TMenuItem;
    Customview1: TMenuItem;
    EnableCustomView: TMenuItem;
    Localfilename1: TMenuItem;
    Datarequestmode1: TMenuItem;
    None1: TMenuItem;
    Inseparatethreadftdelayed1: TMenuItem;
    OnSPACEBAR1: TMenuItem;
    Help1: TMenuItem;
    Helpfile1: TMenuItem;
    N1: TMenuItem;
    GroupBox2: TGroupBox;
    PageControlContentStrings: TPageControl;
    TabSheet1: TTabSheet;
    ContCapt: TLabel;
    ExtCapt: TLabel;
    AcceptBtn: TButton;
    DS: TEdit;
    Ext: TEdit;
    ExtAssigment: TValueListEditor;
    TopSplit: TSplitter;
    mnPreview: TMenuItem;
    Hiddenhotkeys1: TMenuItem;
    NextTab1: TMenuItem;
    PrevTab1: TMenuItem;
    Button1: TButton;
    PM4: TPopupMenu;
    Autosavechanges1: TMenuItem;
    SelDirCombobox: TComboBox;
    AddTab: TTabSheet;
    NewCustomFolderBtn: TButton;
    LabFolder: TLabel;
    Showdirlist1: TMenuItem;
    mnDateTimeInISOFormat: TMenuItem;
    PopupMenuPlugList: TPopupMenu;
    mnPlugListSort: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    mnFloatFieldsTextAndValue: TMenuItem;
    mnFloatFieldsValueOnly: TMenuItem;
    mnFloatFieldsTextOnly: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure AcceptBtnClick(Sender: TObject);
    procedure ExtAssigmentSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PlugListClick(Sender: TObject);
    procedure Rescanpluginsfolder1Click(Sender: TObject);
    procedure FieldsListDblClick(Sender: TObject);
    procedure Selectpluginfolder1Click(Sender: TObject);
    procedure AcceptContentString1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ExtChange(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Deleteextencioncontentstring1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Pasteextencioncontentstring1Click(Sender: TObject);
    procedure Copyextenciondetectstring1Click(Sender: TObject);
    procedure Pasteextencioncontentstring2Click(Sender: TObject);
    procedure Language1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Default1Click(Sender: TObject);
    procedure Directory1Click(Sender: TObject);
    procedure UseDEFvalues1Click(Sender: TObject);
    procedure ExtAssigmentDblClick(Sender: TObject);
    procedure FieldsListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Changeextension1Click(Sender: TObject);
    procedure Changeextension2Click(Sender: TObject);
    procedure Showerrorcode1Click(Sender: TObject);
    procedure Replaceemptyfieldvaluestofilename1Click(Sender: TObject);
    procedure PageControlContentStringsChange(Sender: TObject);
    procedure SplitterBeetwenListBoxesMoved(Sender: TObject);
    procedure Localfilename1Click(Sender: TObject);
    procedure Allowcustomviewfolder1Click(Sender: TObject);
    procedure EnableCustomViewClick(Sender: TObject);
    procedure None1Click(Sender: TObject);
    procedure Inseparatethreadftdelayed1Click(Sender: TObject);
    procedure OnSPACEBAR1Click(Sender: TObject);
    procedure Helpfile1Click(Sender: TObject);
    procedure mnPreviewClick(Sender: TObject);
    procedure DSChange(Sender: TObject);
    procedure NextTab1Click(Sender: TObject);
    procedure PrevTab1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DynamicMenuOnClick(Sender: TObject);
    procedure GetWdxFieldsToMenu(PlugName: string; var Menu: TPopupMenu; Index: Integer);
    procedure WDXToMenu(var Menu: TPopupMenu);
    procedure NewTabClick(Sender: TObject);
    procedure Autosavechanges1Click(Sender: TObject);
    procedure PageControlContentStringsMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure AddTabShow(Sender: TObject);
    procedure NewCustomFolderBtnClick(Sender: TObject);
    procedure SelDirComboboxChange(Sender: TObject);
    procedure Showdirlist1Click(Sender: TObject);
    procedure PlugListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure PageControlContentStringsChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure mnDateTimeInISOFormatClick(Sender: TObject);
    procedure mnPlugListSortClick(Sender: TObject);
    procedure mnFloatFieldsTextAndValueClick(Sender: TObject);
    procedure Addcolumn1Click(Sender: TObject);
    procedure Deletecolumn1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure RecurceScan(dir: string);
    procedure LoadLanguage(LangFile: string);
    procedure ReadContentStrings(ini: TiniFile);
    procedure AddExtensions(Exts, Content: string);
    procedure RenameIniSection(ini: TiniFile; OldName, NewName: string);
    procedure SaveSettings(ini: TiniFile; index: Integer);
    procedure DeleteColumns(ini: TiniFile; index: Integer);
    procedure AddColumnTab;
    procedure DelColumnTab(TabIndex: Integer = -1; DelPrompt: Boolean = True);
    procedure DoAddColumn;
    procedure DoDeleteColumn(Index: Integer; DelPrompt: Boolean = True);
  end;

  TPluginLanguage = record
    { Controls }
    PLPluginsList: string;
    { dialogs }
    PLDirSelect: string;
    CFDirSelect: string;
    PLCFolder: string;
    PLDeleteContentFor: string;
    PLDeleteConfirm: string;
    PLNewExtReq: string;
    PLNewExtReqCapt: string;
    PLLangSelDialog: string;
    PLChangeExt: string;
    PLChangeExtCapt: string;
    PLColumnCapt: string;
    PLDelColumnConfirm: string;
    PLRenameLocalFileName: string;
    PLRenameLocalFileNamePromt: string;
  end;

var
  SuperSettings: TSuperSettings;
  IniPath: string;
  ini: TiniFile;
  WdxDir: string;
  Buf: string;
  LNG: TPluginLanguage;
  PageIndex: Integer = 1;
  tcdir: string;
  CustomIni: TiniFile;
  CustomViewEnabled: Boolean;
  CustomFolderSettingsFileName: string = 'folder.ini';
  PrevSCF, SCF: string; // selected custom folder
  DRM: byte; // data request mode

implementation

uses About, preview;

{$R *.dfm}

function GetPluginPath(PluginName: string): string;
begin
  Result := AnsiReplaceStr(ini.ReadString('Plugins', PluginName, ''),
    '%commander_path%', tcdir);
end;

procedure TSuperSettings.DeleteColumns(ini: TiniFile; index: Integer);
var
  i: Integer;
begin
  if (PageControlContentStrings.PageCount = 1) then
    exit;
  ini.EraseSection('Column #' + inttostr(index + 1));
  PageControlContentStrings.Pages[index].Free;
  ExtAssigment.Strings.Clear;
  for i := index to PageControlContentStrings.PageCount - 1 do
  begin
    RenameIniSection(ini, '[' + PageControlContentStrings.Pages[i].Caption +
      ']', '[Column #' + inttostr(i + 1) + ']');
    PageControlContentStrings.Pages[i].Caption := LNG.PLColumnCapt +
      inttostr(i + 1);
  end;
end;

procedure TSuperSettings.SaveSettings(ini: TiniFile; index: Integer);
var
  i: Integer;
begin
  ini.WriteInteger('Super', 'CustomColumns',
    PageControlContentStrings.ComponentCount + 1);
  for i := 1 to ExtAssigment.RowCount - 1 do
  begin
    if (ExtAssigment.Keys[i] <> '') and (ExtAssigment.Keys[i] <> 'DelayMode') then
    begin
      ini.WriteString('Column #' + inttostr(index + 1), ExtAssigment.Keys[i],
        ExtAssigment.Values[ExtAssigment.Keys[i]]);
    end;
  end;
end;

procedure TSuperSettings.RenameIniSection(ini: TiniFile;
  OldName, NewName: string);
var
  strList: TStringList;
  k: Integer;
begin
  strList := TStringList.Create;
  strList.LoadFromFile(ini.FileName);
  k := strList.IndexOf(OldName);
  if k = -1 then
  begin
    strList.Free;
    exit;
  end;
  strList[k] := NewName;
  strList.SaveToFile(ini.FileName);
  strList.Free;
end;

procedure TSuperSettings.AddExtensions(Exts, Content: string);
  function ParseExtension(var extension: string): string;
  begin
    if pos(';', extension) <> 0 then
    begin
      Result := copy(extension, 1, pos(';', extension) - 1);
      delete(extension, 1, pos(';', extension));
    end
    else
    begin
      Result := extension;
      extension := '';
    end;
  end;

var
  r: Integer;
  t: string;
begin
  if Content = '' then
    exit;
  repeat
    t := ParseExtension(Exts);
    if t = '' then
    begin
      exit; //        Ext.
    end;
    if ExtAssigment.FindRow(t, r) then
      ExtAssigment.Values[t] := Content
    else
      ExtAssigment.InsertRow(t, Content, True);
  until t = '';
end;

procedure TSuperSettings.AddTabShow(Sender: TObject);
begin
  PageControlContentStrings.ActivePageIndex := 0;
end;

procedure TSuperSettings.ReadContentStrings(ini: TiniFile);
var
  strList: TStringList;
  i: Integer;
  ts: string;
begin
  PageIndex := PageControlContentStrings.ActivePageIndex;
  strList := TStringList.Create;
  try
    ini.ReadSection('Column #' + inttostr(PageIndex + 1), strList);
    DRM := ini.ReadInteger('Column #' + inttostr(PageIndex + 1),
      'DelayMode', 0);
    case DRM of
      0:
        None1.Checked := True;
      1:
        Inseparatethreadftdelayed1.Checked := True;
      2:
        OnSPACEBAR1.Checked := True;
    end;
    if (strList.Count <> 0) then
    begin
      for i := 0 to strList.Count - 1 do
      begin
        ts := '';
        if strList[i] <> 'DelayMode' then
          ts := ini.ReadString('Column #' + inttostr(PageIndex + 1),
            strList[i], '');
        if ts <> '' then
          ExtAssigment.InsertRow(strList.Strings[i], ts, True);
      end;
    end;
  finally
    strList.Free;
  end;
end;

procedure TSuperSettings.LoadLanguage(LangFile: string);

  procedure ReadlnEx(var f: textfile; var s: string);
  begin
    if EOF(f) then
    begin
      s := '-1=Missed string';
      exit;
    end;
    readln(f, s);
  end;

var
  f: textfile;
  s: string;
  z: string;
  i: Integer;
begin
  { menus }
  File1.Caption := 'File';
  Save1.Caption := 'Save';
  Autosavechanges1.Caption := 'Autosave changes';
  Language1.Caption := 'Language/';
  Close1.Caption := 'Exit';
  Edit1.Caption := 'Edit';
  Copy1.Caption := 'Copy extension content string';

  Pasteextencioncontentstring1.Caption := 'Paste extension content string';
  Deleteextencioncontentstring1.Caption := 'Delete extension content string';
  Acceptcontentstring1.Caption := 'Add/Apply content string';
  Plugins1.Caption := 'Plugins';
  Selectpluginfolder1.Caption := 'Select plugin folder';
  Rescanpluginsfolder1.Caption := 'Rescan plugins folder';
  About1.Caption := 'About...';
  AddThisFieldtoContentString1.Caption := 'Add field (dblclick)';
  Copyextenciondetectstring1.Caption := 'Copy extension content string';
  Pasteextencioncontentstring2.Caption := 'Paste extension content string';
  Delete1.Caption := 'Delete extension content string';
  Default1.Caption := 'Default';
  Directory1.Caption := 'Folder';
  Options1.Caption := 'Options';
  UseDEFvalues1.Caption := 'Can use default values (if <DEF> setted)';
  Changeextension1.Caption := 'Change extension';
  Changeextension2.Caption := 'Change extension (dblclick)';
  Showerrorcode1.Caption := 'Show error code';
  Replaceemptyfieldvaluestofilename1.Caption :=
    'Replace empty field values to file name';
  Addcolumn1.Caption := 'Add column';
  Deletecolumn1.Caption := 'Delete column';
  // AddColBtn.Caption :='Add column';
  // DeleteColBtn.Caption :='Delete column';
  GroupBox2.Caption := 'Column settings';

  Customview1.Caption := 'Custom view';
  // Customviewfrom1.Caption:='Custom view from';
  // Allowcustomviewfolder1.Caption := 'None (disabled)';
  EnableCustomView.Caption := 'Enable custom view';
  // Localdatabaseonly1.Caption:='Database only';
  // Localdatabaseandlocalfiles1.Caption:='Database and local files';
  Localfilename1.Caption := 'Local filename pattern';
  // Compactdatabase1.Caption:='Compact database';

  Datarequestmode1.Caption := 'Column data request mode';
  None1.Caption := 'As usual';
  Inseparatethreadftdelayed1.Caption := 'In separate thread (ft_delayed)';
  OnSPACEBAR1.Caption := 'On <SPACEBAR> press (ft_ondemand)';
  Help1.Caption := 'Help';
  Helpfile1.Caption := 'Help file';
  mnPreview.Caption := 'Preview';
  PreviewF.Caption := 'Preview';

  { Controls }
  GroupBox1.Caption := 'WDX-plugins';
  LNG.PLPluginsList := 'Plugins list';
  PLCapt.Caption := LNG.PLPluginsList;
  PFLCapt.Caption := 'Plugin fields list';
  ExtCapt.Caption := 'Extension:';
  ContCapt.Caption := 'Content string:';
  AcceptBtn.Caption := 'Add/Apply';
  ExtAssigment.TitleCaptions[0] := 'Ext';
  ExtAssigment.TitleCaptions[1] := 'Content string';
  LNG.PLColumnCapt := 'Column #';
  LabFolder.Caption := 'Folder:';
  NewCustomFolderBtn.Caption := 'Add custom folder';
  { dialogs }
  LNG.PLDirSelect := 'Select folder with WDX plugins:';
  LNG.PLDeleteContentFor := 'Delete content string for ';
  LNG.PLDeleteConfirm := 'Delete confirmation';
  LNG.PLNewExtReq := 'Enter new file extension:';
  LNG.PLNewExtReqCapt := 'New file extension';
  LNG.PLLangSelDialog := 'Select language file';
  LNG.PLChangeExt := 'New extension:';
  LNG.PLChangeExtCapt := 'Change extension';
  LNG.PLDelColumnConfirm :=
    'Are you really sure that you want to delete column number %x%?';
  LNG.PLCFolder := 'Custom folder: ';
  LNG.PLRenameLocalFileName := 'Rename custom settings filename pattern';
  LNG.PLRenameLocalFileNamePromt := 'Enter new filename pattern';
  mnDateTimeInISOFormat.Caption := 'DateTime Field in ISO Format';
  mnFloatFieldsTextAndValue.Caption := 'Text and Value in Float Fields';
  mnFloatFieldsValueOnly.Caption := 'Only Value in Float Fields';
  mnFloatFieldsTextOnly.Caption := 'Only Text in Float Fields (like in TC)';

  if not FileExists(LangFile) then
    exit;

  AssignFile(f, LangFile);
  try
    reset(f);
    while (not EOF(f)) do
    begin
      ReadlnEx(f, s);
      if (Length(s) > 0) and (s[1] = ';') then
        Continue;
      if IsUTF8String(RawByteString(s)) then
        s := UTF8ToUnicodeString(RawByteString(s));
      i := StrToIntDef(copy(s, 1, pos('=', s) - 1), -100);
      if i = -100 then
        Continue;
      z := copy(s, pos('=', s) + 1, length(s));
      case i of
        { menus }
        1:
          File1.Caption := z;
        2:
          Save1.Caption := z;
        3:
          Language1.Caption := z;
        4:
          Close1.Caption := z;
        5:
          Edit1.Caption := z;
        6:
          begin
            Copy1.Caption := z;
            Copyextenciondetectstring1.Caption := z;
          end;
        7:
          begin
            Pasteextencioncontentstring1.Caption := z;
            Pasteextencioncontentstring2.Caption := z;
          end;
        8:
          begin
            Deleteextencioncontentstring1.Caption := z;
            Delete1.Caption := z;
          end;
        9:
          Acceptcontentstring1.Caption := z;
        10:
          Plugins1.Caption := z;
        11:
          Selectpluginfolder1.Caption := z;
        12:
          Rescanpluginsfolder1.Caption := z;
        13:
          About1.Caption := z;
        14:
          AddThisFieldtoContentString1.Caption := z;
        { Controls }
        15:
          GroupBox1.Caption := z;
        16:
          begin
            LNG.PLPluginsList := z;
            PLCapt.Caption := LNG.PLPluginsList;
          end;
        17:
          PFLCapt.Caption := z;
        18:
          ExtCapt.Caption := z;
        19:
          ContCapt.Caption := z;
        20:
          AcceptBtn.Caption := z;
        21:
          ExtAssigment.TitleCaptions[0] := z;
        22:
          ExtAssigment.TitleCaptions[1] := z;
        { dialogs }
        23:
          LNG.PLDirSelect := z;
        24:
          LNG.PLDeleteContentFor := z;
        25:
          LNG.PLDeleteConfirm := z;
        26:
          LNG.PLNewExtReq := z;
        27:
          LNG.PLNewExtReqCapt := z;
        28:
          LNG.PLLangSelDialog := z;
        29:
          Default1.Caption := z;
        30:
          Directory1.Caption := z;
        31:
          Options1.Caption := z;
        32:
          UseDEFvalues1.Caption := z;
        33:
          LNG.PLChangeExt := z;
        34:
          begin
            LNG.PLChangeExtCapt := z;
            Changeextension1.Caption := z;
          end;
        35:
          Changeextension2.Caption := z;
        36:
          Showerrorcode1.Caption := z;
        37:
          Replaceemptyfieldvaluestofilename1.Caption := z;
        38:
          LNG.PLColumnCapt := z;
        39:
          begin
            Addcolumn1.Caption := z;
            // AddColBtn.Caption :=z;
          end;
        40:
          begin
            Deletecolumn1.Caption := z;
            // DeleteColBtn.Caption :=z;
          end;
        // 41: Allowcustomviewfolder1.Caption := z;
        42:
          LNG.PLDelColumnConfirm := z;
        43:
          LNG.PLCFolder := z;
        44:
          GroupBox2.Caption := z;
        45:
          Customview1.Caption := z;
        // 46: Customviewfrom1.Caption:=z;
        47:
          EnableCustomView.Caption := z;
        // 48: Localdatabaseonly1.Caption:=z;
        // 49: Localdatabaseandlocalfiles1.Caption:=z;
        50:
          Localfilename1.Caption := z;
        // 51: Compactdatabase1.Caption:=z;
        52:
          LNG.PLRenameLocalFileName := z;
        53:
          LNG.PLRenameLocalFileNamePromt := z;
        54:
          Datarequestmode1.Caption := z;
        55:
          None1.Caption := z;
        56:
          Inseparatethreadftdelayed1.Caption := z;
        57:
          OnSPACEBAR1.Caption := z;
        58:
          Help1.Caption := z;
        59:
          Helpfile1.Caption := z;
        60:
          begin
            mnPreview.Caption := z;
            PreviewF.Caption := z;
          end;
        61:
          Autosavechanges1.Caption := z;
        62:
          LabFolder.Caption := z;
        63:
          NewCustomFolderBtn.Caption := z;
        65:
          mnDateTimeInISOFormat.Caption := z;
        66:
          mnFloatFieldsTextAndValue.Caption := z;
        67:
          mnFloatFieldsValueOnly.Caption := z;
        68:
          mnFloatFieldsTextOnly.Caption := z;
      end;
    end;
  except
  end;
  closefile(f);
  ExtAssigment.Repaint;
  for I := 0 to PageControlContentStrings.PageCount - 2 do
    PageControlContentStrings.Pages[I].Caption := LNG.PLColumnCapt + IntToStr(I +1);
  //TabSheet1.Caption := LNG.PLColumnCapt + '1';
  // CheckBoxCusFolder.Caption :=LNG.PLCFolder;
  PLCapt.Caption := LNG.PLPluginsList + ' (' + AnsiReplaceStr(lowercase(WdxDir),
    tcdir, '%commander_path%') + ')';
end;

function SetCustomFolder(FromDir: string = ''): string;
var
  TempStr: string;
begin
  TempStr := FromDir;
  if SelectDirectory(LNG.CFDirSelect, '', TempStr) then
  begin
    Result := IncludeTrailingPathDelimiter(TempStr);
  end
  else
  begin
    Result := 'No_Folder';
  end;
end;

function GetWdxFolder(Caption: string; var res: string): Boolean;
var
  TempStr: string;
begin
  Result := SelectDirectory(Caption, '', TempStr);
  if Result then
    res := TempStr
  else
    res := ini.ReadString('Super', 'WdxDir', '?');
end;

function GetMenuLevel(Item: TMenuItem): Integer;
var
  t: TMenuItem;
begin
  Result := 0;
  t := Item;
  while t.Parent.Name <> '' do
  begin
    inc(Result);
    t := t.Parent;
  end;
end;

procedure TSuperSettings.DynamicMenuOnClick(Sender: TObject);
var
  PluginName: string;
  ItemName, SubItemName: string;
  res: string;
begin
  //      :     .
  if GetMenuLevel((Sender as TMenuItem)) = 1 then
  begin
    PluginName := (StringReplace((Sender as TMenuItem).Parent.Caption, '&', '',
      [rfReplaceAll, rfIgnoreCase]));
    ItemName := (StringReplace((Sender as TMenuItem).Caption, '&', '',
      [rfReplaceAll, rfIgnoreCase]));
  end
  else if GetMenuLevel((Sender as TMenuItem)) = 2 then
  begin
    PluginName := (StringReplace((Sender as TMenuItem).Parent.Parent.Caption,
      '&', '', [rfReplaceAll, rfIgnoreCase]));
    ItemName := (StringReplace((Sender as TMenuItem).Parent.Caption, '&', '',
      [rfReplaceAll, rfIgnoreCase]));
    SubItemName := '.' + (StringReplace((Sender as TMenuItem).Caption, '&', '',
      [rfReplaceAll, rfIgnoreCase]));
  end;
  // %FieldName.SubFieldName@PluginName%
  res := '%' + ItemName + SubItemName + '@' + PluginName + '.wdx%';
  DS.Text := DS.Text + res;
end;

procedure TSuperSettings.GetWdxFieldsToMenu(PlugName: string;
  var Menu: TPopupMenu; Index: Integer);
var
  Fields: Integer;
  FName: string;
  UnitVal, TmpFname: string;
  FieldType: Integer;
  m, n, z: TMenuItem;
begin
  Fields := -1;
  m := NewItem(ChangeFileExt(ExtractFileName(PlugName), ''), 0, false, True,
    nil, 0, 'plugin_' + inttostr(Index));
  FieldType := -1;
  FName := ' ';
    while FName <> '' do
    begin
      FName := GetWdxFieldName(PlugName, Fields);
      //  ,      ">",     .
      if FName = '' then
        break;

      if pos('>', FName) = 0 then
      begin
        n := NewItem(FName, 0, false, True, DynamicMenuOnClick, 0,
          'field_' + inttostr(Fields + 1));
        n.Tag := FieldType;
        m.Add(n);
      end
      else
      begin
        FName := FName + '|';
        TmpFname := copy(FName, 1, pos('>', FName) - 1);
        n := NewItem(copy(FName, 1, pos('>', FName) - 1), 0, false, True, nil, 0,
          'field_sub_' + inttostr(Fields + 1));
        n.Tag := FieldType;
        delete(FName, 1, pos('>', FName));
        while length(FName) > 0 do
        begin
          UnitVal := copy(FName, 1, pos('|', FName) - 1);
          delete(FName, 1, pos('|', FName));
          z := NewItem(UnitVal, 0, false, True, DynamicMenuOnClick, 0,
            'subitem_' + inttostr(n.Count));
          z.Tag := FieldType;
          n.Add(z);
        end;
        m.Add(n);
      end;
      inc(Fields);
      FName := 'Anti was here'; //     
    end;
    Menu.Items.Add(m);
end;

procedure GetWdxFieldsToList(PlugName: string; StringList: TStrings);
var
  Fields: Integer;
  FName: string;
  UnitVal, TmpFname: string;
  hLib: THandle;
begin
  Fields := -1;
    repeat
      FName := GetWdxFieldName(PlugName, Fields);
      //  ,      ">",     .
      if pos('>', FName) <> 0 then
      begin
        FName := FName + '|';
        TmpFname := copy(FName, 1, pos('>', FName) - 1);
        delete(FName, 1, pos('>', FName));
        while length(FName) > 0 do
        begin
          UnitVal := copy(FName, 1, pos('|', FName) - 1);
          delete(FName, 1, pos('|', FName));
          StringList.Add(TmpFname + '.' + UnitVal);
        end;
        inc(Fields);
        FName := 'Anti was here'; //     
      end
      else
      begin
        inc(Fields);
        Application.ProcessMessages;
        if FName <> '' then
          StringList.Add(FName);
      end;
    until FName = '';
end;
{
procedure TSuperSettings.RecurceScan(dir: string);
var
  SRec: TSearchRec;
  index: Integer;
begin
  dir := IncludeTrailingPathDelimiter(dir);
  if FindFirst(dir + '*.wdx', FAAnyFile and not FADirectory, SRec) = 0 then
  begin
    index := PlugList.Items.IndexOf(SRec.Name);
    //        
    if (index = -1) and (SRec.Name <> 'SUPER_WDX.wdx') then
    begin
      ini.WriteString('Plugins', SRec.Name,
        AnsiReplaceStr(lowercase(dir + SRec.Name), tcdir, '%commander_path%'));
      PlugList.Items.Add(SRec.Name);
    end;
    Application.ProcessMessages;
  end;
  while FindNext(SRec) = 0 do
  begin
    ini.WriteString('Plugins', SRec.Name,
      AnsiReplaceStr(lowercase(dir + SRec.Name), tcdir, '%commander_path%'));
    index := PlugList.Items.IndexOf(SRec.Name);
    if (index = -1) and (SRec.Name <> 'SUPER_WDX.wdx') then
      PlugList.Items.Add(SRec.Name);
    Application.ProcessMessages;
  end;
  FindFirst(dir + '*.*', FADirectory, SRec);
  while FindNext(SRec) = 0 do
  begin
    if (SRec.Attr and FADirectory <> 0) and (SRec.Name[1] <> '.') then
      RecurceScan(dir + SRec.Name);
  end;
  FindClose(SRec);

end;
}
procedure TSuperSettings.RecurceScan(dir: string);
const
  Extension = '.wdx';
  (*
  {$IFDEF WIN64}
  Extension = '.wdx64';
  {$ENDIF}
  *)
var
  I, index: Integer;
  Str, Name: string;
  Dirs, Files: TStringDynArray;
begin
  if not SysUtils.DirectoryExists(dir) then
    Exit;
  dir := IncludeTrailingPathDelimiter(dir);
  Dirs := IOUtils.TDirectory.GetDirectories(dir);
  SetLength(Dirs, Length(Dirs) + 1);
  Dirs[High(Dirs)] := dir;
  //Files := IOUtils.TDirectory.GetFiles(dir, '*' + Extension, TSearchOption.soAllDirectories);
  for i := low(Dirs) to high(Dirs) do
  begin
    Files := IOUtils.TDirectory.GetFiles(Dirs[i], '*' + Extension,
      TSearchOption.soAllDirectories);
    for Str in Files do
    begin
      name := ExtractFileName(Str);
      index := PlugList.Items.IndexOf(name);
      //        
      if (index = -1) and (not SameText(name, 'SUPER_WDX' + Extension)) then
      begin
        ini.WriteString('Plugins', name, AnsiReplaceText(AnsiLowerCase(Str),
          tcdir, '%commander_path%'));
        if FileExists(ChangeFileExt(str, '.wdx64')) then
          PlugList.Items.AddObject(name, TObject(1))
        else
          PlugList.Items.AddObject(name, TObject(0));
      end;
      // Application.ProcessMessages;
    end;
  end;
end;

procedure TSuperSettings.FormCreate(Sender: TObject);
var
  Wnd: hWnd;
  buff: array [0 .. MAX_PATH] of Char;
  i: Integer;
  tmp: TStringList;
begin
  if FindWindow('TTOTAL_CMD', nil) = 0 then
  begin
    MessageBox(Application.Handle, 'TC not runned!', 'TC not runned',
      MB_ICONINFORMATION);
    Application.Terminate;
  end;

  Wnd := GetWindow(Handle, gw_HWndFirst);
  while Wnd <> 0 do
  begin
    if (Wnd <> Application.Handle) and (GetWindow(Wnd, gw_Owner) = 0) then
    begin
      GetWindowText(Wnd, buff, sizeof(buff) - 1);
      if StrPas(buff) = Application.Title then
      begin
        Halt;
      end;
    end;
    Wnd := GetWindow(Wnd, gw_hWndNext);
  end;

  tcdir := AnsiLowerCase(SysUtils.GetEnvironmentVariable('COMMANDER_PATH'));
  if Trim(tcdir) = '' then
  begin
    MessageBox(Application.Handle,
      'Run program from TC (file panel or button bar)', 'Error', MB_ICONERROR);
    Application.Terminate;
  end;

  PluginPath := IncludeTrailingPathDelimiter(ExtractFilePath(Paramstr(0)));
  IniPath := PluginPath + 'super_wdx.ini';
  ini := TiniFile.Create(IniPath);
  WdxDir := ini.ReadString('Super', 'WdxDir', '');
  WdxDir := AnsiReplaceText(WdxDir, '%commander_path%', tcdir);
  //     
  LoadLanguage(AnsiReplaceText(ini.ReadString('Super', 'Language', ''),
    '%commander_path%', tcdir));
  UseDEFvalues1.Checked := ini.ReadBool('Super', 'Usedef', false);
  Showerrorcode1.Checked := ini.ReadBool('Super', 'ShowError', false);
  mnDateTimeInISOFormat.Checked := ini.ReadBool('Super', 'DateTimeISO', false);
  CustomViewEnabled := ini.ReadBool('Super', 'CustomFoldersView', True);
  Debug := ini.ReadBool('Super', 'Debug', false);
  CustomFolderSettingsFileName := ini.ReadString('Super',
    'CustomFolderFileName', 'folder.ini');

  case ini.ReadInteger('Super', 'TextInFloatFields', 1) of
    0: mnFloatFieldsValueOnly.Checked := True;
    2: mnFloatFieldsTextOnly.Checked := True;
    else  mnFloatFieldsTextAndValue.Checked := True;
  end;


  if CustomViewEnabled then
  begin
    EnableCustomView.Checked := True;
  end
  else
  begin
    EnableCustomView.Checked := false;
    // CheckBoxCusFolder.Enabled :=false;
  end;

  Replaceemptyfieldvaluestofilename1.Checked :=
    ini.ReadBool('Super', 'EmptyReplace', false);
  Autosavechanges1.Checked := ini.ReadBool('Super', 'AutosaveChanges', True);

  for i := 0 to ini.ReadInteger('Super', 'CustomColumns', 1) - 2 do
  begin
    AddColumnTab;
  end;
  ReadContentStrings(ini);
  if (WdxDir = '') or (WdxDir = '?') then
  begin
    if not GetWdxFolder(LNG.PLDirSelect, WdxDir) then
      Application.Terminate; //    
  end;

  RecurceScan(WdxDir);
  WDXToMenu(PM4);

  if FileExists(PluginPath + 'dirlist.lst') then
  begin
    tmp := TStringList.Create;
    try
      tmp.LoadFromFile(PluginPath + 'dirlist.lst');
      for i := 0 to tmp.Count - 1 do
      begin
        if (tmp[i] <> '\') and (SysUtils.DirectoryExists(tmp[i])) then
        begin
          if SelDirCombobox.Items.IndexOf(tmp[i]) = -1 then
            SelDirCombobox.Items.Add(tmp[i]);
        end;
      end;
    finally
      tmp.Free;
    end;
    SelDirCombobox.Items.SaveToFile(PluginPath + 'dirlist.lst');
  end;

  SelDirCombobox.ItemIndex := 0;
  SCF := SelDirCombobox.Text;
  // CheckBoxCusFolder.Caption :=LNG.PLCFolder;
end;

procedure TSuperSettings.AcceptBtnClick(Sender: TObject);
begin
  Acceptcontentstring1.Click;
  if Autosavechanges1.Checked then
    Save1.Click;
end;

procedure TSuperSettings.ExtAssigmentSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  Ext.Text := ExtAssigment.Keys[ARow];
  DS.Text := ExtAssigment.Values[ExtAssigment.Keys[ARow]];
end;

procedure TSuperSettings.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Save1.Click;
  ini.Free;
  CustomIni.Free;
end;

procedure TSuperSettings.PlugListClick(Sender: TObject);
begin
  if PlugList.ItemIndex < 0 then
    exit;

  PlugList.Hint := GetPluginPath(PlugList.Items.Strings[PlugList.ItemIndex]);
  FieldsList.Clear;
  GetWdxFieldsToList(PlugList.Hint, FieldsList.Items);
end;

procedure TSuperSettings.PlugListDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  LB: TListBox;
  Str: string;
begin
  LB := TListBox(Control);
  LB.Canvas.FillRect(Rect);
  Str := LB.Items[Index];
  if Integer(LB.Items.Objects[Index]) = 1 then
    Str := Str + '  [x64]';
  //LB.Canvas.TextOut(Rect.Left + 3, Rect.Height, Str);
  InflateRect(Rect, -3, 0);
  DrawText(LB.Canvas.Handle, PChar(Str), -1, Rect, DT_SINGLELINE or DT_VCENTER);
end;

procedure TSuperSettings.Rescanpluginsfolder1Click(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  try
    PlugList.Clear;
    FieldsList.Clear;
    SelfUnloading;
    RecurceScan(WdxDir);
    WDXToMenu(PM4);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TSuperSettings.FieldsListDblClick(Sender: TObject);
begin
  if (FieldsList.ItemIndex > -1) and
    (FieldsList.ItemIndex < FieldsList.Items.Count) then
  begin
    DS.Text := DS.Text + '%' + FieldsList.Items.Strings[FieldsList.ItemIndex] +
      '@' + PlugList.Items.Strings[PlugList.ItemIndex] + '%';
    if (PreviewF.FileListBox1.FileName <> '') and (PreviewF.Visible) then
      PreviewF.Prevout.Text := GetFormattedvalue('super_wdx.wdx',
        PreviewF.FileListBox1.FileName, SuperSettings.DS.Text);
  end;
end;

procedure TSuperSettings.SelDirComboboxChange(Sender: TObject);
  procedure OptimTabs(ini: TiniFile);
  var
    Am: Integer;
  begin
    for Am := 1 to PageControlContentStrings.PageCount - 2 do
      PageControlContentStrings.Pages[PageControlContentStrings.PageCount
        - 2].Free;
    Am := ini.ReadInteger('Super', 'CustomColumns', 1);
    while PageControlContentStrings.PageCount < Am + 1 do
      AddColumnTab;
    PageControlContentStrings.ActivePageIndex := 0;
  end;

begin
  if SCF <> '' then
    PrevSCF := SCF;
  SCF := SelDirCombobox.Text;
  ExtCapt.Parent := PageControlContentStrings.Pages[0];
  ContCapt.Parent := PageControlContentStrings.Pages[0];
  if SCF = '\' then //   
  begin
    if CustomIni <> nil then
    begin
      SaveSettings(CustomIni, PageControlContentStrings.ActivePageIndex);
      CustomIni.Free;
      CustomIni := nil;
    end;
    ExtAssigment.Strings.Clear;
    Ext.Clear;
    DS.Clear;
    OptimTabs(ini);
    ReadContentStrings(ini);
  end
  else
  begin //    
    if PrevSCF = '\' then
      SaveSettings(ini, PageControlContentStrings.ActivePageIndex);
    ExtAssigment.Strings.Clear;
    Ext.Clear;
    DS.Clear;
    CustomIni := TiniFile.Create(SCF + CustomFolderSettingsFileName);
    OptimTabs(CustomIni);
    ReadContentStrings(CustomIni);
  end;
  PageControlContentStrings.ActivePageIndex := 0;

  exit;
  if CustomIni = nil then
  begin

    if SCF <> '\' then
    begin
      ExtAssigment.Strings.Clear;
      Ext.Clear;
      DS.Clear;
      CustomIni := TiniFile.Create(SCF + CustomFolderSettingsFileName);
      OptimTabs(CustomIni);
      ReadContentStrings(CustomIni);
    end
    else
    begin
      exit;
    end;
  end
  else
  begin
    SaveSettings(CustomIni, PageControlContentStrings.ActivePageIndex);
    CustomIni.Free;
    CustomIni := nil;
    ExtAssigment.Strings.Clear;
    Ext.Clear;
    DS.Clear;
    OptimTabs(ini);
    ReadContentStrings(ini);
  end;
end;

procedure TSuperSettings.Selectpluginfolder1Click(Sender: TObject);
begin
  if not GetWdxFolder(LNG.PLDirSelect, WdxDir) then
    exit;
  PLCapt.Caption := LNG.PLPluginsList + ' (' + WdxDir + ')';
  Rescanpluginsfolder1Click(nil);
  if Autosavechanges1.Checked then
    Save1.Click;
end;

procedure TSuperSettings.AcceptContentString1Click(Sender: TObject);
begin
  AddExtensions(Ext.Text, DS.Text);
end;

procedure TSuperSettings.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TSuperSettings.Delete1Click(Sender: TObject);
begin
  Deleteextencioncontentstring1.Click;
end;

procedure TSuperSettings.Deletecolumn1Click(Sender: TObject);
begin
  //DelColumnTab(PageControlContentStrings.ActivePageIndex, True);
  DoDeleteColumn(PageControlContentStrings.ActivePageIndex, True);
end;

procedure TSuperSettings.ExtChange(Sender: TObject);
begin
  DS.Clear;
end;

procedure TSuperSettings.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TSuperSettings.Deleteextencioncontentstring1Click(Sender: TObject);
var
  ini: TiniFile;
  PageIndex: Integer;
begin
  PageIndex := PageControlContentStrings.ActivePageIndex;
  if ExtAssigment.Focused and (ExtAssigment.Keys[ExtAssigment.row] <> '') then
    case MessageBox(Application.Handle,
      pchar(LNG.PLDeleteContentFor + ' ' + ExtAssigment.Keys[ExtAssigment.row] + '?'),
      pchar(LNG.PLDeleteConfirm), mb_yesno + mb_iconquestion) of
      ID_Yes:
        begin
          if CustomIni <> nil then
            ini := CustomIni
          else
            ini := settings.ini;
          ini.DeleteKey('Column #' + inttostr(PageIndex + 1),
            ExtAssigment.Keys[ExtAssigment.row]);
          ExtAssigment.DeleteRow(ExtAssigment.row);
        end;
    end
end;

procedure TSuperSettings.Copy1Click(Sender: TObject);
begin
  Buf := ExtAssigment.Values[ExtAssigment.Keys[ExtAssigment.row]];
end;

procedure TSuperSettings.Pasteextencioncontentstring1Click(Sender: TObject);
begin
  AddExtensions(InputBox(pchar(LNG.PLNewExtReq), pchar(LNG.PLNewExtReqCapt),
    ''), Buf);
end;

procedure TSuperSettings.Copyextenciondetectstring1Click(Sender: TObject);
begin
  Copy1.Click;
end;

procedure TSuperSettings.Pasteextencioncontentstring2Click(Sender: TObject);
begin
  Pasteextencioncontentstring1.Click;
end;

procedure TSuperSettings.Language1Click(Sender: TObject);
begin
  SelLNG.Title := LNG.PLLangSelDialog;
  SelLNG.InitialDir := ExtractFilePath(Application.ExeName) + 'LNG';
  if SelLNG.Execute(Handle) and (SelLNG.FileName <> '') then
  begin
    LoadLanguage(SelLNG.FileName);
    ini.WriteString('Super', 'Language',
      AnsiReplaceStr(lowercase(SelLNG.FileName), tcdir, '%commander_path%'));
  end;
end;

procedure TSuperSettings.Save1Click(Sender: TObject);
begin
  ini.WriteString('Super', 'WdxDir', AnsiReplaceStr(lowercase(WdxDir), tcdir,
    '%commander_path%'));
  ini.WriteBool('Super', 'CustomFoldersView', CustomViewEnabled);
  if CustomIni <> nil then
  begin
    SaveSettings(CustomIni, PageControlContentStrings.ActivePageIndex);
  end
  else
  begin
    SaveSettings(ini, PageControlContentStrings.ActivePageIndex);
  end;
end;

procedure TSuperSettings.mnDateTimeInISOFormatClick(Sender: TObject);
begin
  ini.WriteBool('Super', 'DateTimeISO', mnDateTimeInISOFormat.Checked)
end;

procedure TSuperSettings.Default1Click(Sender: TObject);
begin
  Ext.Text := '<DEF>';
end;

procedure TSuperSettings.Directory1Click(Sender: TObject);
begin
  Ext.Text := '<DIR>';
end;

procedure TSuperSettings.DoAddColumn;
begin
  AddColumnTab;
  PageControlContentStrings.ActivePageIndex := PageControlContentStrings.PageCount - 2;
  ExtCapt.Parent := PageControlContentStrings.ActivePage;
  ContCapt.Parent := PageControlContentStrings.ActivePage;
  PageControlContentStringsChange(PageControlContentStrings);
end;

procedure TSuperSettings.DoDeleteColumn(Index: Integer; DelPrompt: Boolean = True);
var
  ini: TiniFile;
  i: Integer;
begin
  if (PageControlContentStrings.PageCount = 1) or
    (Index = PageControlContentStrings.PageCount - 1) or
    (Index < 0) then
    Exit;

  PageIndex := Index;

  if CustomIni <> nil then
    ini := CustomIni
  else
    ini := settings.ini;

  if DelPrompt then
    if MessageBox(Application.Handle,
      pchar(AnsiReplaceStr(LNG.PLDelColumnConfirm, '%x%',
      inttostr(PageIndex + 1))), pchar(LNG.PLDeleteConfirm),
      mb_yesno + mb_iconquestion) <> ID_Yes then
      exit;
  ExtCapt.Parent := nil;
  ContCapt.Parent := nil;

  ini.EraseSection('Column #' + inttostr(index + 1));
  PageControlContentStrings.Pages[index].Free;
  ExtAssigment.Strings.Clear;

  for i := index to PageControlContentStrings.PageCount - 1 do
  begin
    RenameIniSection(ini, '[Column #' + IntToStr(i + 2) + ']',
      '[Column #' + inttostr(i + 1) + ']');
    PageControlContentStrings.Pages[i].Caption := LNG.PLColumnCapt +
      inttostr(i + 1);
  end;

  if PageControlContentStrings.PageCount = 1 then
    DoAddColumn;

  if PageIndex = PageControlContentStrings.PageCount - 1 then
    PageControlContentStrings.ActivePageIndex := 0;
  Ext.Clear;
  DS.Clear;
  ReadContentStrings(ini);
  ExtCapt.Parent := PageControlContentStrings.ActivePage;
  ContCapt.Parent := PageControlContentStrings.ActivePage;
  PageControlContentStrings.Pages[PageControlContentStrings.PageCount - 1]
    .Caption := '+';
end;

procedure TSuperSettings.UseDEFvalues1Click(Sender: TObject);
begin
  if UseDEFvalues1.Checked then
    ini.WriteBool('Super', 'Usedef', True)
  else
    ini.WriteBool('Super', 'Usedef', false)
end;

procedure TSuperSettings.WDXToMenu(var Menu: TPopupMenu);
var
  index: Integer;
begin
  Menu.Items.Clear;
  for index := 0 to PlugList.Items.Count - 1 do
    GetWdxFieldsToMenu(GetPluginPath(PlugList.Items[index]), Menu, index);
end;

procedure TSuperSettings.ExtAssigmentDblClick(Sender: TObject);
var
  s, c: string;
  r: Integer;
begin
  r := 0;
  if ExtAssigment.Keys[ExtAssigment.row] = '' then
    exit;
  s := InputBox(pchar(LNG.PLChangeExtCapt), pchar(LNG.PLChangeExt), '');
  if s <> '' then
  begin
    if ExtAssigment.FindRow(s, r) then
    //     ,  r -    .
    begin
      c := ExtAssigment.Values[ExtAssigment.Keys[ExtAssigment.row]];
      // c - .   
      ExtAssigment.DeleteRow(ExtAssigment.row); //   
      ExtAssigment.Values[ExtAssigment.Keys[r]] := c;
      //     
    end
    else
    begin
      ExtAssigment.Keys[ExtAssigment.row] := s;
    end;
  end;
end;

procedure TSuperSettings.FieldsListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_RETURN:
      AddThisFieldtoContentString1.Click;
  end;
end;

procedure TSuperSettings.Changeextension1Click(Sender: TObject);
begin
  ExtAssigment.OnDblClick(self);
end;

procedure TSuperSettings.Changeextension2Click(Sender: TObject);
begin
  ExtAssigment.OnDblClick(self);
end;

procedure TSuperSettings.Showdirlist1Click(Sender: TObject);
begin
  SelDirCombobox.DroppedDown := not SelDirCombobox.DroppedDown;
  SelDirCombobox.SetFocus;
end;

procedure TSuperSettings.Showerrorcode1Click(Sender: TObject);
begin
  ini.WriteBool('Super', 'ShowError', Showerrorcode1.Checked)
end;

procedure TSuperSettings.Replaceemptyfieldvaluestofilename1Click
  (Sender: TObject);
begin
  ini.WriteBool('Super', 'EmptyReplace', Replaceemptyfieldvaluestofilename1.Checked)
end;

procedure TSuperSettings.PageControlContentStringsChange(Sender: TObject);
var
  ini: TiniFile;
begin
  if PageControlContentStrings.ActivePageIndex =PageControlContentStrings.PageCount -1 then PageControlContentStrings.ActivePageIndex :=0;
  ExtCapt.Parent := PageControlContentStrings.ActivePage;
  ContCapt.Parent := PageControlContentStrings.ActivePage;
  Ext.Clear;
  DS.Clear;
  if CustomIni <> nil then
    ini := CustomIni
  else
    ini := settings.ini;
  SaveSettings(ini, PageIndex);
  ExtAssigment.Strings.Clear;
  ReadContentStrings(ini);
end;

procedure TSuperSettings.PageControlContentStringsChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange := PageControlContentStrings.GetTabFromCursor <>
    PageControlContentStrings.PageCount - 1;
end;

procedure TSuperSettings.PageControlContentStringsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  case Button of
    mbLeft:  begin
      if PageControlContentStrings.GetTabFromCursor <>
        PageControlContentStrings.PageCount-1 then exit;
      DoAddColumn;
    end;
    mbMiddle:begin
      //DelColumnTab (PageControlContentStrings.GetTabFromCursor, not (ssShift in Shift));
      DoDeleteColumn(PageControlContentStrings.GetTabFromCursor, not (ssShift in Shift));
    end;
  end;
end;

procedure TSuperSettings.Addcolumn1Click(Sender: TObject);
begin
  DoAddColumn;
end;

procedure TSuperSettings.AddColumnTab;
var
  Page: TTabSheet;
begin
  Page := TTabSheet.Create(PageControlContentStrings);
  Page.PageControl := PageControlContentStrings;
  Page.Caption := LNG.PLColumnCapt +
    inttostr(PageControlContentStrings.PageCount - 1);
  Page.PageIndex := PageControlContentStrings.PageCount - 2;
end;

procedure TSuperSettings.DelColumnTab(TabIndex: Integer = -1;
  DelPrompt: Boolean = True);
var
  ini: TiniFile;
  procedure ReparseCol(ini: TiniFile; f, t: Integer);
  var
    i: Integer;
  begin
    for i := f + 2 to t + 2 do
    begin
      RenameIniSection(ini, '[Column #' + inttostr(i) + ']',
        '[Column #' + inttostr(i - 1) + ']');
    end;
  end;

begin
  if (PageControlContentStrings.PageCount < 3) or (PageIndex = 0) or
    (PageIndex = PageControlContentStrings.PageCount - 1) then
    exit;

  if TabIndex <> -1 then
    PageIndex := TabIndex;

  if CustomIni <> nil then
    ini := CustomIni
  else
    ini := settings.ini;
  if DelPrompt then
    if MessageBox(Application.Handle,
      pchar(AnsiReplaceStr(LNG.PLDelColumnConfirm, '%x%',
      inttostr(PageIndex + 1))), pchar(LNG.PLDeleteConfirm),
      mb_yesno + mb_iconquestion) <> ID_Yes then
      exit;
  ExtCapt.Parent := PageControlContentStrings.Pages[0];
  ContCapt.Parent := PageControlContentStrings.Pages[0];
  if (PageIndex <> PageControlContentStrings.PageCount - 1) then
    ReparseCol(ini, PageIndex, PageControlContentStrings.PageCount - 2);
  DeleteColumns(ini, PageIndex);
  if PageIndex = PageControlContentStrings.PageCount - 1 then
    PageControlContentStrings.ActivePageIndex := 0;
  Ext.Clear;
  DS.Clear;
  ReadContentStrings(ini);
  ExtCapt.Parent := PageControlContentStrings.ActivePage;
  ContCapt.Parent := PageControlContentStrings.ActivePage;
  PageControlContentStrings.Pages[PageControlContentStrings.PageCount - 1]
    .Caption := '+';
end;

procedure TSuperSettings.SplitterBeetwenListBoxesMoved(Sender: TObject);
begin
  PFLCapt.Left := FieldsList.Left;
  if PFLCapt.Left < PLCapt.Left + PLCapt.Width + 5 then
    PFLCapt.Left := PLCapt.Left + PLCapt.Width + 5;
  PlugList.Invalidate;
end;

procedure TSuperSettings.Localfilename1Click(Sender: TObject);
begin
  ini.WriteString('Super', 'CustomFolderFileName',
    InputBox(LNG.PLRenameLocalFileName, LNG.PLRenameLocalFileNamePromt,
    ini.ReadString('Super', 'CustomFolderFileName', 'folder.ini')));
end;

procedure TSuperSettings.Allowcustomviewfolder1Click(Sender: TObject);
begin
  CustomViewEnabled := false;
end;

procedure TSuperSettings.Autosavechanges1Click(Sender: TObject);
begin
  ini.WriteBool('Super', 'AutosaveChanges', Autosavechanges1.Checked)
end;

procedure TSuperSettings.Button1Click(Sender: TObject);
var
  PT: TPoint;
begin
  PT := Mouse.CursorPos;
  if Assigned(Button1.Parent) then
  begin
    PT := Point(Button1.Left + Button1.Width, Button1.Top);
    PT := Button1.Parent.ClientToScreen(PT);
  end;
  PM4.Popup(PT.X, PT.Y);
end;

procedure TSuperSettings.EnableCustomViewClick(Sender: TObject);
begin
  CustomViewEnabled := EnableCustomView.Checked;
  if Autosavechanges1.Checked then
    Save1.Click;
  // CheckBoxCusFolder.Enabled :=EnableCustomView.Checked;
end;

procedure SaveColumnDataRequestMode(column, reqMode: byte);
var
  ini: TiniFile;
begin
  if CustomIni <> nil then
    ini := CustomIni
  else
    ini := settings.ini;
  ini.WriteInteger('Column #' + inttostr(column), 'DelayMode', reqMode);
end;

procedure TSuperSettings.None1Click(Sender: TObject);
begin
  DRM := 0;
  SaveColumnDataRequestMode(PageControlContentStrings.ActivePageIndex + 1, DRM);
  if Autosavechanges1.Checked then
    Save1.Click;
end;

procedure TSuperSettings.Inseparatethreadftdelayed1Click(Sender: TObject);
begin
  DRM := 1;
  SaveColumnDataRequestMode(PageControlContentStrings.ActivePageIndex + 1, DRM);
  if Autosavechanges1.Checked then
    Save1.Click;
end;

{ function TSuperSettings.ItemAtPos(TabControlHandle: HWND; X,
  Y: Integer): Integer;
  var
  HitTestInfo : TTCHitTestInfo;
  HitIndex : Integer;
  begin
  HitTestInfo.pt.x := X;
  HitTestInfo.pt.y := Y;
  HitTestInfo.flags := 0;
  HitIndex := SendMessage(TabControlHandle, TCM_HITTEST, 0, Longint(@HitTestInfo));
  Result := HitIndex;
  end; }

procedure TSuperSettings.OnSPACEBAR1Click(Sender: TObject);
begin
  DRM := 2;
  SaveColumnDataRequestMode(PageControlContentStrings.ActivePageIndex + 1, DRM);
  if Autosavechanges1.Checked then
    Save1.Click;
end;

procedure TSuperSettings.Helpfile1Click(Sender: TObject);
begin

  if FileExists(extractfilepath(Application.ExeName) + 'super_help.chm') then
  begin
    ShellExecute(Application.Handle, 'open',
      pchar(extractfilepath(Application.ExeName) + 'super_help.chm'), nil,
      nil, SW_SHOW);
  end
  else
  begin
    MessageBox(Application.Handle, 'Help file not found', 'Help',
      0 + MB_ICONINFORMATION);
  end;
end;

procedure TSuperSettings.mnFloatFieldsTextAndValueClick(Sender: TObject);
begin
  if mnFloatFieldsTextOnly.Checked then
    ini.WriteInteger('Super', 'TextInFloatFields', 2)
  else if mnFloatFieldsValueOnly.Checked then
    ini.WriteInteger('Super', 'TextInFloatFields', 0)
  else
    ini.WriteInteger('Super', 'TextInFloatFields', 1);
end;

procedure TSuperSettings.mnPlugListSortClick(Sender: TObject);
begin
  PlugList.Sorted := True;
  PlugList.Sorted := False;
  WDXToMenu(PM4);
end;

procedure TSuperSettings.mnPreviewClick(Sender: TObject);
begin
  if PreviewF.Visible then
    PreviewF.Hide
  else
    PreviewF.Show;
end;

procedure TSuperSettings.DSChange(Sender: TObject);
begin
  if SuperSettings.Visible = false then
    exit;
  if (PreviewF.Visible) and (PreviewF.FileListBox1.FileName <> '') then
    PreviewF.Prevout.Text := GetFormattedvalue('super_wdx.wdx',
      PreviewF.FileListBox1.FileName, SuperSettings.DS.Text);
end;

procedure TSuperSettings.NewCustomFolderBtnClick(Sender: TObject);
var
  SCF: string;
begin
  SCF := SetCustomFolder(SelDirCombobox.Text);
  if SCF <> 'No_Folder' then
  begin
    if SelDirCombobox.Items.IndexOf(SCF) = -1 then
      SelDirCombobox.Items.Add(SCF);
    SelDirCombobox.ItemIndex := SelDirCombobox.Items.IndexOf(SCF);
    SelDirCombobox.Items.SaveToFile(PluginPath + 'dirlist.lst');
    SelDirCombobox.OnChange(self);
  end;
end;

procedure TSuperSettings.NewTabClick(Sender: TObject);
begin
  AddColumnTab;
end;

procedure TSuperSettings.NextTab1Click(Sender: TObject);
begin
  if PageControlContentStrings.ActivePageIndex +
    1 = PageControlContentStrings.PageCount - 1 then
  begin
    PageControlContentStrings.ActivePageIndex := 0;
    ExtCapt.Parent := PageControlContentStrings.ActivePage;
    ContCapt.Parent := PageControlContentStrings.ActivePage;
    exit;
  end;
  if (PageControlContentStrings.PageCount >
    PageControlContentStrings.TabIndex + 1) then
    PageControlContentStrings.TabIndex := PageControlContentStrings.TabIndex + 1
  else
  begin
    PageControlContentStrings.TabIndex := 0;
  end;
  ExtCapt.Parent := PageControlContentStrings.ActivePage;
  ContCapt.Parent := PageControlContentStrings.ActivePage;
end;

procedure TSuperSettings.PrevTab1Click(Sender: TObject);
begin
  if PageControlContentStrings.ActivePageIndex = 0 then
  begin
    PageControlContentStrings.ActivePageIndex :=
      PageControlContentStrings.PageCount - 2;
    ExtCapt.Parent := PageControlContentStrings.ActivePage;
    ContCapt.Parent := PageControlContentStrings.ActivePage;
    exit;
  end;

  if (PageControlContentStrings.TabIndex <> 0) then
    PageControlContentStrings.TabIndex := PageControlContentStrings.TabIndex - 1
  else
  begin
    PageControlContentStrings.TabIndex :=
      PageControlContentStrings.PageCount - 1;
  end;
  ExtCapt.Parent := PageControlContentStrings.ActivePage;
  ContCapt.Parent := PageControlContentStrings.ActivePage;
end;

initialization
  //ReportMemoryLeaksOnShutdown := True;

end.
