unit preview;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, WdxFieldsProc, Vcl.ExtCtrls;

type
  TPreviewF = class(TForm)
    FileListBox1: TFileListBox;
    PrevOut: TMemo;
    Splitter1: TSplitter;
    Panel1: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    procedure FileListBox1Change(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PreviewF: TPreviewF;

implementation

uses Settings;

{$R *.dfm}

procedure TPreviewF.FileListBox1Change(Sender: TObject);
begin
  Caption := SuperSettings.DS.Text;
  if FileListBox1.FileName <> '' then
    PrevOut.Text := GetFormattedValue('super_wdx.wdx', FileListBox1.FileName,
      SuperSettings.DS.Text);
end;

procedure TPreviewF.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Ord(Key) = VK_ESCAPE then
    Hide;
end;

end.
